using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

using BigSock.UI;
using BigSock.Service;
using BigSock.Item;

namespace BigSock.Interact {
    public class Chest : MonoBehaviour, IInteractable
    {
        [SerializeField] private string _prompt;
        [SerializeField] private Animator animator;
        [SerializeField] private string goldenChestOpen = "OpeningGoldChest";
        [SerializeField] private string goldenChestClose = "ClosingGoldChest";
        [SerializeField] private string idleGoldChest = "Idle";

        public SpriteRenderer spriteRenderer;
        public Sprite closedSprite;
        public Sprite openedSprite;
        public List<IItem> items;

        void Start() {
            animator = gameObject.GetComponent<Animator>();
            items = ItemService.SINGLETON.Get3Random();
        }

        public List<IItem> GetChestItems() {
            return items;
        }

        public void ItemNotPicked() {
            GetComponent<Animator>().Play(goldenChestClose);
        }

        public string InteractionPrompt => _prompt;

        public bool Interact(Interactor interactor) {
            if (spriteRenderer.sprite != openedSprite) {
            var chestContents = PrefabService.SINGLETON.Instance("UI/ChestContents", GameObject.FindWithTag("MainCamera").transform.position+new Vector3(1000,600,0));
            chestContents.gameObject.GetComponent<ChestDisplay>().setChestObject(this.gameObject);
            chestContents.transform.SetParent(GameObject.Find("Canvas").transform);
            GetComponent<Animator>().Play(goldenChestOpen);
            return true;
            } else return false;
        }
    }
}
